#! /usr/bin/python

#
# ShicksDaemon.py                                                             
#                                                                      
# Copyright (C) 2001,2002 Gerson Kurz (not@p-nand-q.com)
# BSD-Licensed. This is free software, enjoy!

"""UNIX-Daemon for Shicks!

This is a UNIX-Daemon that starts the POP3 server and the SMTP server automatically. 

"""

import ShicksTrace, maildb, os, sys, POP3Server, SMTPServer, threading

class ServerThread(threading.Thread):
    def __init__(self,callback):
        threading.Thread.__init__(self)
        self.callback = callback

    def run(self):
        print "ServerThread() starting."
        self.callback()
        print "ServerThread() terminating."

def ReadConfiguration():
    TRACE_DIRECTORY = maildb.GetConfigSettings("Logfiles",(os.name == "nt") and "c:\\shicks\\log" or "/usr/share/shicks/log")
    try:
        os.makedirs( TRACE_DIRECTORY )
    except:
        pass
    ShicksTrace.TraceFileName = os.path.join(TRACE_DIRECTORY,"shicks.log")
    ShicksTrace.Enable(bOutputToConsole=0)    

if os.fork() == 0:
    os.setsid()
    sys.stdout = open("/dev/null","w")
    sys.stdin = open("/dev/null","r")
    
    POP3 = ServerThread(POP3Server.StartPOP3Server)
    POP3.start()
    
    SMTP = ServerThread(SMTPServer.StartSMTPServer)
    SMTP.run()

